%{!?upstream:   %define upstream utsushi}
%{!?uversion:   %{error: uversion undefined, define to match source archive}}

Name:           imagescan
Version:        3.10.0
Release:        1%{?dist}
Summary:        Next Generation Image Acquisition Utilities

Vendor:         SEIKO EPSON CORPORATION
License:        GPLv3+
URL:            http://download.ebz.epson.net/dsc/search/01/search/?OSC=LX
Source0:        %{upstream}-%{uversion}.tar.gz
Source1:        %{name}.desktop
Source2:        %{name}.conf
Patch0:         rebranding.patch
Patch1:         gtkmm-2.20-compat.patch
Patch2:         gdk-pixbuf-format.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%define Magick  %{?centos:Image}%{!?centos:Graphics}Magick

Requires:       %{Magick}

BuildRequires:  desktop-file-utils, pkgconfig, libtool-ltdl-devel
BuildRequires:  gtkmm24-devel, sane-backends-devel, libjpeg-devel
BuildRequires:  libtiff-devel, %{Magick}

%if 06 == 0%{?centos}
BuildRequires:  bzip2-devel, zlib-devel
%else
BuildRequires:  boost-devel
%endif

%if 06 == 0%{?centos} || 0%{?suse_check:1}
BuildRequires:  libudev-devel
%else
BuildRequires:  systemd-devel
%endif

%if 0%{?suse_check:1}
BuildRequires:  libusb-1_0-devel, libGraphicsMagick++-devel
%else
BuildRequires:  libusb1-devel, %{Magick}-c++-devel
%endif

%description
This software provides applications to easily turn hard-copy documents
and imagery into formats that are more amenable to computer processing.

Included are a native driver for a number of EPSON scanners and a
compatibility driver to interface with software built around the SANE
standard.

The current package supports the DS-40, DS-510, DS-520, DS-560, DS-760,
DS-860, DS-5500, DS-6500, DS-7500, DS-50000, DS-60000, and DS-70000 as
well as the L220/L360 Series, L365/L366 Series, L455 Series, L565/L566
Series, L655 Series, PX-M860F, PX-M7050 Series, PX-M7050FX Series,
WF-8510/8590 Series, and WF-R8590 Series.


%if 06 == 0%{?centos} || 0%{?suse_check:1}
%debug_package
%endif


%prep
%setup -q -n %{upstream}-%{uversion}
%patch -P 0 -p1
sed -i 's/^utsushi-0\.\([^ \t]*\)  /imagescan-3.\1/' NEWS

# Upstream requires gtkmm-2.20 or later but CentOS 6 only has 2.18.
# Apply a backward compatibility patch and make configure accept the
# version that CentOS 6 ships.  Avoid the need for running autotools
# as that is likely to fail due to their version requirements.  Also
# apply a patch to work around a GDK pixbuf image format recognition
# issue.
#
%if 06 == 0%{?centos}
%patch -P 1 -p1
sed -i 's/\(gtkmm-2\.4 >= 2\)\.20/\1.18/g' configure
%patch -P 2 -p1
%endif

%build
%configure \
    --with-jpeg \
    --with-tiff \
    --with-gtkmm \
    --with-sane \
    --with-magick \
    --with-magick-pp \
    --disable-static
make %{?_smp_mflags} BACKEND_NAME=%{name}

%install
rm -rf %{buildroot}
make install BACKEND_NAME=%{name} DESTDIR=%{buildroot}
desktop-file-install \
    --dir=%{buildroot}%{_datadir}/applications \
    %{SOURCE1}
test -d %{buildroot}%{_sysconfdir}/%{name} \
    || %{__mkdir_p} %{buildroot}%{_sysconfdir}/%{name}
install -m 644 %{SOURCE2} \
    %{buildroot}%{_sysconfdir}/%{name}/%{name}.conf
mv %{buildroot}%{_bindir}/%{upstream} %{buildroot}%{_bindir}/%{name}
rm -rf %{buildroot}%{_includedir}
rm -rf %{buildroot}%{_libdir}/lib*.a
rm -rf %{buildroot}%{_libdir}/lib*.la
rm -rf %{buildroot}%{_libdir}/lib*.so
rm -rf %{buildroot}%{_libdir}/%{upstream}/lib*.a
rm -rf %{buildroot}%{_libdir}/%{upstream}/lib*.so
rm -rf %{buildroot}%{_libdir}/%{upstream}/sane/lib*.a
rm -rf %{buildroot}%{_libdir}/%{upstream}/sane/lib*.la
rm -rf %{buildroot}%{_libdir}/%{upstream}/sane/lib*.so
rm -rf %{buildroot}%{_libdir}/sane/lib*.a
rm -rf %{buildroot}%{_libdir}/sane/lib*.la
rm -rf %{buildroot}%{_libdir}/sane/lib*.so
%find_lang %{upstream}

%clean
rm -rf %{buildroot}


%define have_sane_dll_d %(test -d %{_sysconfdir}/sane.d/dll.d && echo true)

%files -f %{upstream}.lang
%defattr(-,root,root,-)
%doc NEWS README AUTHORS
%doc COPYING
%{_bindir}/%{name}
%{_libdir}/%{upstream}/
%if "%{_libdir}" != "%{_libexecdir}"
%{_libexecdir}/%{upstream}/
%endif
%{_libdir}/sane/libsane-%{name}.*
%{_datadir}/applications/%{name}.desktop
%{_datadir}/%{upstream}/
%config(noreplace) %{_sysconfdir}/%{name}/%{name}.conf
%if "true" == "%{have_sane_dll_d}"
%{_sysconfdir}/sane.d/dll.d/%{name}
%endif
%{_sysconfdir}/udev/rules.d/%{upstream}-esci.rules


%if "true" != "%{have_sane_dll_d}"
#
#  Modify SANE's dll.conf during (un)installation
#
%post
dll=%{_sysconfdir}/sane.d/dll.conf
if [ -n "`grep '^[ \t]*#[ \t#]*%{name}' ${dll}`" ]
then				# uncomment existing entry
    sed -i 's,^[ \t]*#[ \t#]*\(%{name}\),\1,' ${dll}
elif [ -z "`grep %{name} ${dll}`" ]
then				# append brand new entry
    echo %{name} >> ${dll}
fi

%preun
if [ $1 = 0 ]
then				# comment out existing entry
    dll=%{_sysconfdir}/sane.d/dll.conf
    if [ -n "`grep '^[ \t]*%{name}' ${dll}`" ]
    then
        sed -i 's,^[ \t]*\(%{name}\),#\1,' ${dll}
    fi
fi
%endif


%changelog
* Fri Jun 19 2015 Olaf Meeuwissen <olaf.meeuwissen@avasys.jp> - 3.10.0-1
- new upstream
- add new models to the package description
- activate building of debuginfo packages
* Wed Mar 18 2015 Olaf Meeuwissen <olaf.meeuwissen@avasys.jp> - 3.9.0-1
- new upstream
- add new models to the package description
- added conditionalized build support for other distributions and
  versions
- switched back to GraphicsMagick as the default, ImageMagick is only
  used when GraphicsMagick is not available
* Tue Jan 27 2015 Olaf Meeuwissen <olaf.meeuwissen@avasys.jp> - 3.8.3-1
- new upstream
* Tue Nov 18 2014 Olaf Meeuwissen <olaf.meeuwissen@avasys.jp> - 3.8.2-1
- new upstream
* Thu Nov  6 2014 Olaf Meeuwissen <olaf.meeuwissen@avasys.jp> - 3.8.1-1
- new upstream
* Fri Oct 17 2014 Olaf Meeuwissen <olaf.meeuwissen@avasys.jp> - 3.8.0-1
- new upstream
* Fri Aug  8 2014 Olaf Meeuwissen <olaf.meeuwissen@avasys.jp> - 3.7.0-1
- new upstream
- dropped HAL dependency
- switched from GraphicsMagick to ImageMagick
* Fri Apr 25 2014 Olaf Meeuwissen <olaf.meeuwissen@avasys.jp> - 3.6.0-1
- new upstream
* Wed Feb  5 2014 Olaf Meeuwissen <olaf.meeuwissen@avasys.jp> - 3.5.0-1
- new upstream
- add GraphicsMagick build and run-time dependency
* Thu Nov 21 2013 Olaf Meeuwissen <olaf.meeuwissen@avasys.jp> - 3.4.0-1
- new upstream
* Thu Sep  5 2013 Olaf Meeuwissen <olaf.meeuwissen@avasys.jp> - 3.3.0-1
- new upstream
- renamed the SANE backend to match the package name
* Mon Mar 11 2013 Olaf Meeuwissen <olaf.meeuwissen@avasys.jp> - 3.1.0-1
- new upstream
* Fri Nov  2 2012 Olaf Meeuwissen <olaf.meeuwissen@avasys.jp> - 3.0.0-1
- first rebranded public release of Utsushi
